package net.sourceforge.jpowergraph.manipulator;

import net.sourceforge.jpowergraph.pane.JGraphPane;

import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.MouseTrackListener;
import org.eclipse.swt.graphics.GC;


/**
 * A manipulator gets to process UI events in the graph pane.
 */
public interface Manipulator extends MouseListener,MouseMoveListener, MouseTrackListener, KeyListener,FocusListener {
    /**
     * Sets the graph pane to the manipulator.
     *
     * @param graphPane                     the graph pane
     */
    void setGraphPane(JGraphPane graphPane);
    /**
     * Returns the manipulator name. This is used to better search manipulators.
     *
     * @return                              the name of the manipulator
     */
    String getName();
    /**
     * Gives the manipulator an opportunity to update the screen.
     *
     * @param g                             the graphics where drawing should be performed
     */
    void paint(GC g);
    /**
     * Notifies the manipulator that the graph pane has been scrolled.
     */
    void notifyGraphPaneScrolled();
    void dispose();
    boolean isDisposed();
}
